/*-------------------------------------------------------------------------------------------------
Author     : Sergey Makarov
Company    : Husky Energy
Description: A extension controller for Activity Detail view serves both desktop and mobile views
Inputs     : N/A
Test Class : VTT_ActivityDetailTimeLogControllerXTest
History    : 04.14.2016 ssd added logic to get operator on call from Activity, and added 
                            error handling for no operator on call found
             06.06.2018 mp Added orderflocId and flocId with getOrderFlocId(order) and getflocId(activity) methods
                            to retreive correct Floc object's IDs (to be used in URL link on page)
             12-June-18 mz reset Estimated_Rescheduled_Date__c in controller
             06.29.2018 ssd changed getflocId to populateFlocId and added name to display on page.
             19.07.2018 mp updated ValidateRunningTally and executeWSUpdateNotification methods (fix for bug found in W-001175)  
             14.08.2018 mp added callSAP_UpdateNotificationRemote method to fix sending comment to SAP in one.app (W-001175)
             16.08.2018 mp W-001222 added numOfPageMessages
             14.02.2019 mb W-001367 check for user context
------------------------------------------------------------------------------------------------*/
public without sharing class VTT_ActivityDetailTimeLogControllerX {

    private final Work_Order_Activity__c woActivity;
    private final HOG_Maintenance_Servicing_Form__c workOrder;
    
    private final String retUrl;

    private List<SelectOption> partsOptions = new List<SelectOption>();
    private List<SelectOption> damagesOptions = new List<SelectOption>();
    private List<SelectOption> causesOptions = new List<SelectOption>();
    private List<SelectOption> usersOptions = new List<SelectOption>();

    private final static String NONE_ITEM = '--None--';
    private Boolean isReloadAttachments;
    private List<Attachment> attachments;
    private List<Attachment> woattachments;    
    
    private User operatorOnCall;

    private Map<String, String> mapPartCode = new Map<String, String>();    

    public Boolean renderErrorMessageOnMobile {get; private set;}

    public String partItem {get; set;}
    public String damageItem {get; set;}
    public String damageText {get; set;}    
    public String causeItem {get; set;}    
    public String causeText {get; set;}     
    public String userItem {get; set;} 

    //woAId for sf1 redirect
    public Id woId {get; set;}
    public Id mWoId {get; set;}
     //Check for SF1 app context
    public Boolean isSalesforce1 {get; set;}

    public SelectOption[] selectedTradesmen { get; set; }
    public SelectOption[] allTradesmen { get; set; }    
    public SelectOption[] vendorAccounts { get; set; }
    public ID assignedVendor {get; set;}
 
    public Work_Order_Activity__c  damageRecord {get; private set;}   
    public VTT_WorkFlowEngine workflowEngine {get; private set;} 
    public Boolean EquipmentWorkOrder {get; private set;}
    public String filter {get; private set;}
    public Boolean showPartsDamageCause {get; private set;}
    public List<Work_Order_Activity_Assignment__c> tradesmanAssignments {get; private set;}
    
    public Integer numOfPageMessages { get; set; }
    public Id orderFlocId { get; set; }
    public Id activityFlocId { get; set; }
    public String nameOfOrderFloc { get; set; }
    public String nameOfActivityFloc { get; set; } 
    public Boolean renderOrderFlocLink { get; set; }
    public Boolean renderActivityFlocLink { get; set; }
    public Double availableTimeSnapShot = null;
    public Integer numberOfChecked { get; set; }
    public Boolean checkedAll { get; set; }
    public Boolean checkedTwenty { get; set; }
    public Double userTotalDuration { get; set; }
    public Static Integer ALLOWED_NUMBER_OF_SELECTED_WOA = 200;

    private HOG_Cause__c defaultCause;
    
    // The extension constructor initializes the private member
    // variable mysObject by using the getRecord method from the standard
    // controller.
    public VTT_ActivityDetailTimeLogControllerX(ApexPages.StandardController stdController) {
        retUrl = ApexPages.currentPage().getParameters().get('retURL');
        
        if(!Test.isRunningTest()) {
            stdController.addFields(new List<String>{'Maintenance_Work_Order__r.Work_Order_Number__c', 'Maintenance_Work_Order__r.Planner_Group__c'
                , 'Maintenance_Work_Order__r.Order_Type__c', 'Yard__c','Functional_Equipment_Level__c','Sub_System__c','System__c','Well_Event__c'
                ,'Location__c','Facility__c','Functional_Location__c','Operating_District__c','Business_Unit__c'});
        } 
        
        this.woActivity = (Work_Order_Activity__c)stdController.getRecord();
        woId = this.woActivity.id;
        this.woActivity.Estimated_Rescheduled_Date__c = null;
        isSalesforce1 = VTT_Utilities.IsSalesforce1User();
        
        workflowEngine = new VTT_WorkflowEngine(stdController);

        filter = System.currentPageReference().getParameters().get('filter');

        damageRecord = woActivity;
        workOrder = [Select Id,
                        Equipment__r.Catalogue_Code__c,
                        HOG_Service_Request_Notification_Form__c,
                        MAT_Code__c,
                        Order_Type__c,
                        Functional_Location__c,
                        Facility__c,
                        Location__c,
                        Well_Event__c,
                        System__c,
                        Sub_System__c,
                        Functional_Equipment_Level__c,
                        Yard__c,
                        Operating_Field_AMU_Lookup__c, 
                        Operating_Field_AMU_Lookup__r.Is_Thermal__c,
                        Operating_District_Lookup__c,
                        Business_Unit_Lookup__c
                    From HOG_Maintenance_Servicing_Form__c
                    Where Id =: woActivity.Maintenance_Work_Order__c];
        mWoId = workOrder.Id;
        tradesmanAssignments = [Select Id, Name, Tradesman__r.Name, Tradesman__r.Tradesman_Status__c,
                                       Tradesman__r.Tradesman_Status_Date__c, Tradesman__r.Tradesman_Status_Duration__c
                                From Work_Order_Activity_Assignment__c
                                Where Work_Order_Activity__c =: woActivity.Id];
        

        EquipmentWorkOrder =  (this.woActivity.Maintenance_Work_Order__r.Equipment__c <> null && this.woActivity.Maintenance_Work_Order__r.Equipment__r.Catalogue_Code__c <> null);        
        showPartsDamageCause = !MaintenanceServicingUtilities.SkipPartsDamageCause(workOrder) &&
            !MaintenanceServicingUtilities.SkipPartsDamageCauseSysAdmin(workOrder);
        List<HOG_Cause__c> result = [Select Id, Cause_Code__c, Cause_Description__c From HOG_Cause__c WHERE Cause_Description__c like'Other%' limit 1];
        defaultCause = (result.size() > 0) ? result[0] : null;
        partsSelection();
        causesSelection();

        //get Floc Id on Work Order
        populateFlocId(workOrder);
        renderOrderFlocLink = orderFlocId == null ? false : true;

        //get Floc Id on Work Order Activity
        populateFlocId(woActivity);
        renderActivityFlocLink = activityFlocId == null ? false : true;

        VendorAccountsSetup();

        assignedVendor = this.woActivity.Assigned_Vendor__c; 
        TradesmanAssignmentSetup();
        
        isReloadAttachments = true; //To load 
        renderErrorMessageOnMobile = false; //Don't want to load pagemessages from workflowengine on mobile unless specified
    }

    // W-001367 - check users context and then render buttons accordingly
    public Boolean getIsLightningUser(){
        return HOG_GeneralUtilities.isUserUsingLightning();
    }

    public String getStartedAtEquipment() {
        return VTT_Utilities.ACTIVITY_STATUS_STARTEDATSITE;
    }

    public Boolean getIsThermal() {
        if(this.woActivity.Operating_Field_AMU__c != null) return this.woActivity.Operating_Field_AMU__r.Is_Thermal__c;
        if (this.workOrder.Operating_Field_AMU_Lookup__c != null) return this.workOrder.Operating_Field_AMU_Lookup__r.Is_Thermal__c;
        return false;
    }

    public List<SelectOption> getPartsOptions()
    {
        return partsOptions;
    }

    public List<SelectOption> getDamagesOptions()
    {
        return damagesOptions;
    }

    public List<SelectOption> getCausesOptions()
    {
        return causesOptions;
    }

    public List<SelectOption> getUsersOptions()
    {
        return usersOptions;
    }

    public Attachment attachmentFile {
        get {
            if(attachmentFile == null)
                attachmentFile = new Attachment();
            return attachmentFile;
        }
        private set;
    }

    public List<Attachment> getAttachments() {
        if(isReloadAttachments) {
            attachments = [Select Id, Name, ParentId, Description
                            From Attachment
                            Where ParentId =: woActivity.Id];
            isReloadAttachments = false;
        }

        return attachments;
    }

    public List<Attachment> getWorkOrderAttachments() {
        if(isReloadAttachments) {
            woattachments = [Select Id, Name, ParentId, Description
                            From Attachment
                            Where ParentId =: woActivity.Maintenance_Work_Order__c];
            //isReloadAttachments = false;
        }

        return woattachments;
    }

    public User getOperatorOnCall() {

        if(operatorOnCall == null) {
            Id locationId = (woActivity.Maintenance_Work_Order__r.Location__c != null) ? 
                             woActivity.Maintenance_Work_Order__r.Location__c :
                             (woActivity.Location__c != null) ? woActivity.Location__c :
                             null;

            Id facilityId = (woActivity.Maintenance_Work_Order__r.Facility__c != null) ?
                             woActivity.Maintenance_Work_Order__r.Facility__c :
                             (woActivity.Facility__c != null) ? woActivity.Facility__c :
                             null;
            
            if(locationId != null) {
                Location__c location = [Select Id, Route__r.Operator_On_Call__r.Operator__c
                           From Location__c
                           Where Id =: locationId];

                List<User> operatorsOnCall = [Select Id, Name, Phone, MobilePhone
                                              From User
                                              Where Id =: location.Route__r.Operator_On_Call__r.Operator__c];
                operatorOnCall = (operatorsOnCall != null && !operatorsOnCall.isEmpty()) ? operatorsOnCall[0] : null;
            } else if (facilityId != null) {
                Facility__c facility = [Select Id, Plant_Section__r.Operator_On_Call__r.Operator__c
                                        From Facility__c
                                        Where Id =: facilityId];

                List<User> operatorsOnCall = [Select Id, Name, Phone, MobilePhone
                                              From User
                                              Where Id =: facility.Plant_Section__r.Operator_On_Call__r.Operator__c];
                operatorOnCall = (operatorsOnCall != null && !operatorsOnCall.isEmpty()) ? operatorsOnCall[0] : null;
            }
        }

        return operatorOnCall;
    }

    public Integer getMaxAutoCompleteAllowed() {
        return ALLOWED_NUMBER_OF_SELECTED_WOA;
    }
    
    public Boolean getIsSelectedGreaterThanAllowed() {
        return numberOfChecked > ALLOWED_NUMBER_OF_SELECTED_WOA;
    }

    /**
     * [MP 6.6.2018 W-001148 Create links to FL or Location from WOA detail page
     * This method populates the orderflocId and activity flocId with correct FLOC object's id to be used in URL link on VTT_ActivityDetailTimeLog.page]
     * @param  obj [Order or Activity that is redered on page]
     * @return     [description]
     */
    public void populateFlocId(SObject obj) {

        Id flocId = null;
        String flocName = null;
        String floc = (string) obj.get('Functional_Location__c');
        System.debug('floc: ' + floc + ' obj: ' +obj);
        String objectName = String.valueOf(obj.getSObjectType());

        if(objectName == 'HOG_Maintenance_Servicing_Form__c' || objectName == 'Work_Order_Activity__c') {
            //Yard
            if(obj.get('Yard__c') != null && flocId == null){
                try {
                    Yard__c yard = [SELECT Id, Name FROM Yard__c WHERE Functional_Location_Description_SAP__c =: floc];
                    flocId = yard.Id;
                    flocName = yard.Name;
                } catch (Exception e) {
                    System.debug('flocId on Functional Equipment Level not found, Exception: ' + e + ' flocId: ' +flocId);
                }
            //Functional Equipment Level
            } else if(obj.get('Functional_Equipment_Level__c') != null && flocId == null){
                try {
                    Functional_Equipment_Level__c fel = [SELECT Id, Name FROM Functional_Equipment_Level__c WHERE Functional_Location_Description_SAP__c =: floc];
                    flocId = fel.Id;
                    flocName = fel.Name;
                } catch (Exception e) {
                    System.debug('flocId on Functional Equipment Level not found, Exception: ' + e + ' flocId: ' +flocId);
                }
            //Sub-System
            } else if(obj.get('Sub_System__c') != null && flocId == null){
                try {
                    Sub_System__c subSystem = [SELECT Id, Name FROM Sub_System__c WHERE Functional_Location_Description_SAP__c =: floc];
                    flocId = subSystem.Id;
                    flocName = subSystem.Name;
                } catch (Exception e) {
                    System.debug('flocId on Sub-System not found, Exception: ' + e + ' flocId: ' +flocId);
                }
            //System    
            } else if(obj.get('System__c') != null && flocId == null){
                try {
                    System__c sys = [SELECT Id, Name FROM System__c WHERE Functional_Location_Description_SAP__c =: floc];
                    flocId = sys.Id;
                    flocName = sys.Name;
                } catch (Exception e) {
                    System.debug('flocId on System not found, Exception: ' + e + ' flocId: ' +flocId);
                }
            //Well Event    
            } else if(obj.get('Well_Event__c') != null && flocId == null){
                try {
                    Well_Event__c wellEvent = [SELECT Id, Name FROM Well_Event__c WHERE Functional_Location_Description_SAP__c =: floc];
                    flocId = wellEvent.Id;
                    flocName = wellEvent.Name;
                } catch (Exception e) {
                    System.debug('flocId on Well Event not found, Exception: ' + e + ' flocId: ' +flocId);
                }
            //Location
            } else if(obj.get('Location__c') != null && flocId == null){
                try {
                    Location__c wellLocation = [SELECT Id, Name FROM Location__c WHERE Functional_Location_Description_SAP__c =: floc];
                    flocId = wellLocation.Id;
                    flocName = wellLocation.Name;
                } catch (Exception e) {
                    System.debug('flocId on Location not found, Exception: ' + e + ' flocId: ' +flocId);
                }
            //Facility
            } else if(obj.get('Facility__c') != null && flocId == null){
                try {
                    Facility__c fac = [SELECT Id, Name FROM Facility__c WHERE Functional_Location__c =: floc];
                    flocId = fac.Id;
                    flocName = fac.Name;
                } catch (Exception e) {
                    System.debug('flocId on Facility not found, Exception: ' + e + ' flocId: ' +flocId);
                }
            //Operating Field (AMU) on Order
            } else if(objectName == 'HOG_Maintenance_Servicing_Form__c'){
                if(obj.get('Operating_Field_AMU_Lookup__c') != null && flocId == null){
                    System.debug('flocId: ' + flocId + ' IN ' +objectName);
                    try {
                        Field__c field = [SELECT Id, Name FROM Field__c WHERE Functional_Location__c =: floc];
                        flocId = field.Id;
                        flocName = field.Name;
                    } catch (Exception e) {
                        System.debug('flocId on Operating Field (AMU) not found, Exception: ' + e + ' flocId: ' +flocId);
                    }
                }
                //Operating District on Order
                else if(obj.get('Operating_District_Lookup__c') != null && flocId == null){
                    System.debug('flocId: ' + flocId + ' IN ' +objectName);
                    try {
                        Operating_District__c operDistrict = [SELECT Id, Name FROM Operating_District__c WHERE Functional_Location__c =: floc];
                        flocId = operDistrict.Id;
                        flocName = operDistrict.Name;
                    } catch (Exception e) {
                        System.debug('flocId on Operating District not found, Exception: ' + e + ' flocId: ' +flocId);
                    }
                //Business Unit on Order
                } else if(obj.get('Business_Unit_Lookup__c') != null && flocId == null){
                    System.debug('flocId: ' + flocId + ' IN ' +objectName);
                    try {
                        Business_Unit__c businessUnit = [SELECT Id, Name FROM Business_Unit__c WHERE Functional_Location__c =: floc];
                        flocId = businessUnit.Id;
                        flocName = businessUnit.Name;
                    } catch (Exception e) {
                        System.debug('flocId on Business Unit not found, Exception: ' + e + ' flocId: ' +flocId);
                    }
                }
            } else if(objectName == 'Work_Order_Activity__c'){
                //Operating Field (AMU) on Activity
                if(obj.get('Operating_Field_AMU__c') != null && flocId == null){
                    System.debug('flocId: ' + flocId + ' IN 2 ' +objectName);
                    try {
                        Field__c field = [SELECT Id, Name FROM Field__c WHERE Functional_Location__c =: floc];
                        flocId = field.Id;
                        flocName = field.Name;
                    } catch (Exception e) {
                        System.debug('flocId on Operating Field (AMU) not found, Exception: ' + e + ' flocId: ' +flocId);
                    }
                //Operating District on Activity
                } else if(obj.get('Operating_District__c') != null && flocId == null){
                    System.debug('flocId: ' + flocId + ' IN 2 ' +objectName);
                    try {
                        Operating_District__c operDistrict = [SELECT Id, Name FROM Operating_District__c WHERE Functional_Location__c =: floc];
                        flocId = operDistrict.Id;
                        flocName = operDistrict.Name;
                    } catch (Exception e) {
                        System.debug('flocId on Operating District not found, Exception: ' + e + ' flocId: ' +flocId);
                    }
                //Business Unit on Activity
                } else if(obj.get('Business_Unit__c') != null && flocId == null){
                    System.debug('flocId: ' + flocId + ' IN 2 ' +objectName);
                    try {
                        Business_Unit__c businessUnit = [SELECT Id, Name FROM Business_Unit__c WHERE Functional_Location__c =: floc];
                        flocId = businessUnit.Id;
                        flocName = businessUnit.Name;
                    } catch (Exception e) {
                        System.debug('flocId on Business Unit not found, Exception: ' + e + ' flocId: ' +flocId);
                    }
                }
            }

            if(objectName == 'HOG_Maintenance_Servicing_Form__c') {
                orderflocId = flocId;
                nameOfOrderFloc = flocName;
            } else {
                activityFlocId = flocId;
                nameOfActivityFloc = flocName;
            }
        }
    }

    // Builds picklist of parts   
    public void partsSelection()
    {
        partsOptions.clear();

        String catalogueCode = '';
        String partCode = NONE_ITEM;
        String partDescription = NONE_ITEM;
        
        if (EquipmentWorkOrder)
        {
            catalogueCode = this.woActivity.Maintenance_Work_Order__r.Equipment__r.Catalogue_Code__c;            
            partCode = this.woActivity.Part__r.Part_Code__c;
            partDescription = this.woActivity.Part__r.Part_Description__c;
        }
        else
        {
            return;
        }
                    
        final HOG_Part__c[] results = 
            [Select
                    Id,
                    Part_Code__c,
                    Part_Description__c
                From HOG_Part__c 
                Where Catalogue_Code__c = :catalogueCode
            ];
                
        mapPartCode.clear();

        final Map<String, String> mapResults = new Map<String, String>();
        
        for (HOG_Part__c r : results)
        {
            mapResults.put(r.Part_Code__c, r.Part_Description__c);
            mapPartCode.put(r.Part_Code__c, r.Id);           
        }
                                          
        partItem = 
            selectionOption
            (
                partsOptions, 
                mapResults, 
                partCode,
                partDescription,
                true              
            );
                
        damagesSelection();      
    }   

    // Builds picklist of damages   
    public void damagesSelection()
    {
        damagesOptions.clear();
        system.debug('partItem');
        system.debug(partItem);

        final HOG_Damage__c[] results = 
            [Select
                    Id,
                    Damage_Code__c,
                    Damage_Description__c
                From HOG_Damage__c 
                Where Part_Code__c = :partItem
            ];
                
        final Map<String, String> mapResults = new Map<String, String>();
        
        for (HOG_Damage__c r : results)
        {
            mapResults.put(r.Id, r.Damage_Description__c);
        }

        damageItem = 
            selectionOption
            (
                damagesOptions, 
                mapResults, 
                NONE_ITEM,
                NONE_ITEM,
                true              
            );                            
    }

    // Builds picklist of causes
    public void causesSelection()
    {
        causesOptions.clear();
                    
        final HOG_Cause__c[] results = 
            [Select
                    Id,
                    Cause_Code__c,
                    Cause_Description__c
                From HOG_Cause__c 
            ];
        
        final Map<String, String> mapResults = new Map<String, String>();
        
        for (HOG_Cause__c r : results)
        {
            mapResults.put(r.Id, r.Cause_Description__c);
        }           
                                                 
        causeItem = 
            selectionOption
            (
                causesOptions, 
                mapResults, 
                NONE_ITEM,
                NONE_ITEM,
                true              
            );                                             
    } 
    

    public PageReference JobComplete()
    {   
        ValidateRunningTally();
        if(!this.workflowengine.runningTallyValueValid){
            return null;
        }
        if(workflowengine.OptimisticLockCheck() == false){
            return null;
        }

        Savepoint sp = Database.setSavepoint();
        try{
            if (EquipmentWorkOrder) {
                damageRecord.Part__c = partItem == NONE_ITEM ? null : mapPartCode.get(partItem);
                damageRecord.Damage__c = damageItem == NONE_ITEM ? null : damageItem;
                damageRecord.Cause__c = causeItem == NONE_ITEM ? null : causeItem;
            }
            else {
                damageRecord.Cause__c = (defaultCause != null) ? defaultCause.id : null;
            }
            VTT_Utilities.executeTriggerCode = false;
            upsert damageRecord;
            VTT_Utilities.executeTriggerCode = true;

            //TODO create reschedule request
            if(ApexPages.currentPage().getParameters().get('requestReschedule') != null) {
                Boolean isRequestSchedule = ApexPages.currentPage().getParameters().get('requestReschedule') == 'true';
                if(isRequestSchedule) {
                    Work_Order_Activity_Reschedule_Request__c requestToSchedule = new Work_Order_Activity_Reschedule_Request__c (
                        Work_Order_Activity__c = this.woActivity.Id,
                        Tradesman__c = this.workflowEngine.Tradesman.Id,
                        Tech_s_Comments__c = this.workflowEngine.ActionComment
                    );
                    // mbrimus - this forces recalculate and then runs triggers so i have added flag to disable it
                    VTT_Utilities.executeTriggerCode = false;
                    insert requestToSchedule;
                    VTT_Utilities.executeTriggerCode = true;
                }
            }
            
            this.workflowEngine.JobComplete_End();

        } catch(Exception ex) {
            Database.rollback(sp);
            //VTT_Utilities.logError(ex);
            System.debug('JobComplete->Error: ' + ex.getMessage());
            ApexPages.addMessage(new ApexPages.Message(ApexPages.severity.ERROR, ex.getMessage()));
        }
        return null;            
    }

    public PageReference executeWSUpdateNotification()
    {   
        ValidateRunningTally();
        System.debug('executeWSUpdateNotification runningTallyValueValid is: '+this.workflowengine.runningTallyValueValid);
        if(this.workflowengine.runningTallyValueValid) {
            
            //if(!VTT_Utilities.IsSalesforce1User()){
            //  return this.workflowEngine.ReloadCurrentPage();   
            //} else {
            VTT_IntegrationUtilities.SAP_UpdateNotification(damageRecord.id);
            PageReference redirectPage = Page.VTT_ActivityDetailTimeLog;
            redirectPage.setRedirect(true);
            redirectPage.getParameters().put('id',damageRecord.id);
            return redirectPage;
            //}      
        } else {
            ApexPages.addMessage(new ApexPages.Message(ApexPages.severity.ERROR, 'There is a problem with validation of the running tally.'));
            return null;
        }
    }
    
    @RemoteAction
    public static void callSAP_UpdateNotificationRemote(String damageRecordId) {
        VTT_IntegrationUtilities.SAP_UpdateNotification(damageRecordId);
    }

    public PageReference VTT_Cancel()
    {
        PageReference pageRef;

        if(retUrl != null && !String.isEmpty(retUrl)) {
            //Redirect to Calendar
            pageRef = new PageReference(retUrl);
        } else {
            pageRef = new PageReference('/apex/VTT_ActivityListView');
            if(filter <> null)
            {
                pageRef.getParameters().put('filter',filter);
            }
        }
        pageRef.setRedirect(true);

        return pageRef;  
    }

    public PageReference VTT_Assignment()
    {

        PageReference pageRef = new PageReference('/apex/VTT_TradesmanAssignment?id=' + this.woActivity.id);
        pageRef.setRedirect(true);
        return pageRef;  
    }

    public PageReference UpdateAssignment()
    {

        //first delete everything from assignment table

        List<Work_Order_Activity_Assignment__c> assignmentList =  [select id, Tradesman__c from Work_Order_Activity_Assignment__c where Rejected__c <> true and Work_Order_Activity__c = :woActivity.id];
        delete assignmentList;

        assignmentList = new List<Work_Order_Activity_Assignment__c>();

        for ( SelectOption so : selectedTradesmen ) {
            Work_Order_Activity_Assignment__c assinmentRecord = new Work_Order_Activity_Assignment__c();
            assinmentRecord.Tradesman__c = so.getValue();
            assinmentRecord.Work_Order_Activity__c = this.woActivity.id;
            assignmentList.add(assinmentRecord);
        }
        system.debug('this.woActivity.id');
        system.debug(this.woActivity.id);        


        system.debug('assignmentList');
        system.debug(assignmentList);
        insert assignmentList;

        this.woActivity.Assigned_Vendor__c = this.assignedVendor;
        upsert this.woActivity;

        PageReference pageRef = new PageReference('/apex/VTT_ActivityDetailTimeLog?id=' + this.woActivity.id);
        pageRef.setRedirect(true);
        return pageRef;  
    }

    public PageReference ExitAssignment()
    {

        PageReference pageRef = new PageReference('/apex/VTT_ActivityDetailTimeLog');
        //pageRef.setRedirect(true);
        return pageRef;  
    }

    public PageReference EditActivity() {
        String editActivityRedirect = '/' + woActivity.Id + '/e?retURL=' + EncodingUtil.urlEncode('/' + woActivity.Id, 'UTF-8');
        PageReference pageRef = new PageReference(editActivityRedirect);
        return pageRef;
    }

    private void  VendorAccountsSetup()
    {

        ID VendorAccountRecordTypeID;
       //assign recordtype SMakarov
        List<RecordType>  recTypes = [select id, name, sobjectType,developername from recordtype where sobjecttype = 'Account' and developername = 'HOG_Vendor_Account_Record' LIMIT 1];
        if(recTypes .size()>0)
        {
            VendorAccountRecordTypeID = recTypes[0].id; 
        }            

        List<Account> accountList = [select id, name from Account where recordtypeID = :VendorAccountRecordTypeID order by name];

        vendorAccounts = new List<SelectOption>();
        for(Account acc: accountList)
        {
            SelectOption accOption = new SelectOption(acc.id, acc.Name);
            vendorAccounts.add(accOption);
        }
    }

    public void  TradesmanAssignmentSetup()
    {
        selectedTradesmen = new List<SelectOption>();
        allTradesmen  = new List<SelectOption>();

        //assignedVendor; 

        List<Contact> contactList = [select id, name from Contact where AccountID = :assignedVendor 
        and User__c <> null order by name
        limit 1000];

        for(Contact contactRec: contactList)
        {
            SelectOption accOption = new SelectOption(contactRec.id, contactRec.Name);
            allTradesmen.add(accOption);
        }  


        
        Set<ID> contactSet = new Set<ID>();
        for(Work_Order_Activity_Assignment__c woaa : [select id, Tradesman__c from Work_Order_Activity_Assignment__c where Rejected__c <> true and Work_Order_Activity__c = :woActivity.id])
        {
            contactSet.add(woaa.Tradesman__c);
        }

        for(Contact tradesmancontact : [select id, name, Phone, email, Tradesman_Status__c, Current_Work_Order_Activity__c, Tradesman_Status_Date__c, User__c 
                                        from Contact where id in :contactSet order by name limit 1000])
        {
            SelectOption accOption = new SelectOption(tradesmancontact.id, tradesmancontact.Name);
            selectedTradesmen.add(accOption);
        }
    }

    public PageReference Upload() {
        attachmentFile.OwnerId = UserInfo.getUserId();
        attachmentFile.ParentId = woActivity.Id;
        attachmentFile.IsPrivate = false;

        try {
            System.debug('attachmentFile.Name: ' + attachmentFile.Name);
            insert attachmentFile;
        } catch (DmlException e) {
            ApexPages.addMessage(new ApexPages.Message(ApexPages.severity.ERROR, 'Error uploading attachment: ' + e.getMessage()));
            renderErrorMessageOnMobile = true;
            return null;
        } finally {
            attachmentFile = new Attachment();
        }

        isReloadAttachments = true;
        return null;
    }

    // Create a picklist selection of items
    // Can be moved to the Utilities class
    private String selectionOption
    (
        List<SelectOption> optionList, // the picklist
        Map<String, String> mapItems, // the items in picklist
        String selectedId, // the selected item value
        String selectedName, // the selected item label
        Boolean selectPickNone // to select the "--None--" in Add mode
    )
    {                
        final String pickNone = NONE_ITEM;
        String selectedValue = selectedId;
        
        optionList.add(new SelectOption(pickNone, pickNone));

        for(String key : mapItems.keySet())
        {
            selectedValue = key;
            optionList.add(new SelectOption(selectedValue, mapItems.get(key)));            
        }
                    
        if (selectedId != pickNone)
        {
            selectedValue = selectedId;
        }
                           
        // sort the items
        sortSelectOption(optionList);
                      
        return selectPickNone ? selectedId : selectedValue;
    }

    // Sorts items/labels in SelectOption
    private void sortSelectOption(List<Selectoption> opts) 
    {        
        final Map<String, Selectoption> mapping = new Map<String, Selectoption>();
        
        // Suffix to avoid duplicate values like same labels or values are in inbound list 
        Integer suffix = 1;
        for (Selectoption opt : opts)
        { 
            mapping.put(opt.getLabel() + suffix++, opt);  
        }
                                    
        final List<String> sortKeys = new List<String>();
        sortKeys.addAll(mapping.keySet());
        sortKeys.sort();
        
        // clear the original collection to rebuild it
        opts.clear();
        
        for (String key : sortKeys)
        { 
            opts.add(mapping.get(key));
        }
    }
    
    // Recount available time
    public PageReference recountAvailableTime(){
        
        // Sets snapshot that will be used to set runningTally value back in case of error
        if(availableTimeSnapShot == null){
            availableTimeSnapShot = this.workflowEngine.runningTally;
        }
        
        // Counts total user input
        userTotalDuration = countTotalUserDefinedDuration(this.workflowEngine.AvailableActivitiesToComplete);
        
        for(VTT_WorkFlowEngine.AvailableActivity w : this.workflowEngine.AvailableActivitiesToComplete){
            
            // Available time cannot be less then total user input at any time, 
            // else display error and revert runningTally back to snapshot value
            if(availableTimeSnapShot - 1 >= userTotalDuration || (availableTimeSnapShot >= 0 && availableTimeSnapShot < 1)){
                Decimal dec = availableTimeSnapShot - userTotalDuration;
                this.workflowEngine.runningTallyValueValid = true;
                this.workflowEngine.runningTally = dec.setScale(2);
                ApexPages.getMessages().clear();

            } else {

                // Used to calculate how many minutes user has to 
                // substract from their time and display it in message
                Decimal subStract = userTotalDuration-availableTimeSnapShot;
                subStract = substract.setScale(2);
                subStract = subStract.round(RoundingMode.Up)+1;
                
                this.workflowEngine.runningTallyValueValid = false;
                this.workflowEngine.runningTally = subStract-(subStract+subStract);
                
                ApexPages.addMessage(new ApexPages.Message(ApexPages.Severity.WARNING, 'Value incorrect, running tally time can\'t be less then 0. At least 1 minute needs to be updated on the initial WOA'));
                ApexPages.addMessage(new ApexPages.Message(ApexPages.Severity.INFO,  'Your total time spend on selected WOAs is ' + userTotalDuration + ' minute(s), substract ' + subStract + ' minute(s) from any activity'));
            }
        }
        return null;
    }

    // This is used just to count total time that user has inputed
    public Double countTotalUserDefinedDuration(List<VTT_WorkFlowEngine.AvailableActivity> activities){
        Double duration = 0;
        for(VTT_WorkFlowEngine.AvailableActivity w : activities){
            duration += w.userDurationInput;
        }
        return duration;
    }

    // Distribute available time to selected activities that have "0" values in userDataInput field (no manual user data input)
    public void distributeAvailableTime(){
        
        recountAvailableTime();

        if(numberOfChecked > 0){
            
            Integer numberOfCheckedGreaterThanZero = 0;

            workflowEngine.ActivitiesToDistributeTimeTo.clear();

            for(VTT_WorkFlowEngine.AvailableActivity w : this.workflowEngine.AvailableActivitiesToComplete){

                if(w.MarkToComplete && w.userDurationInput > 0){
                    
                    numberOfCheckedGreaterThanZero++;

                } else if (w.MarkToComplete && w.userDurationInput == 0){
                    //add availableActivity to the list of activities to be applied time distributon button
                    workflowEngine.ActivitiesToDistributeTimeTo.add(w);
                }
            }

            
            if( (numberOfChecked - numberOfCheckedGreaterThanZero) >= 1){
                
                // Counts how many minutes we need redistribute to other activities
                Integer timeToBeAssignedToSelectedWOAs = ((availableTimeSnapShot.intValue()-1) - userTotalDuration.intValue())/((numberOfChecked - numberOfCheckedGreaterThanZero)+1);
                
                // Set this value to other selected activities
                for(VTT_WorkFlowEngine.AvailableActivity w : this.workflowEngine.ActivitiesToDistributeTimeTo){
                    if(w.MarkToComplete && w.userDurationInput == 0){
                        w.userDurationInput = timeToBeAssignedToSelectedWOAs > 0 ? timeToBeAssignedToSelectedWOAs : 0;
                    }
                }  
            }

            // Called for validation and also for recounting tally time
            recountAvailableTime();
        }
    }

    public Integer CountNumberOfChecked() {
        numberOfChecked = 0;
        for(VTT_WorkFlowEngine.AvailableActivity w : this.workflowEngine.AvailableActivitiesToComplete){
             if(w.MarkToComplete){
                numberOfChecked++;
             }
        }
        
        return numberOfChecked;
    }

    // When user selects activity to complete input is shown and activity is marked as mass completed
    // Also input checkboxes get disabled if the limit of checkable checkboxes is met
    public PageReference selectActivityToAutoComplete(){
        
        CountNumberOfChecked();
        
        for(VTT_WorkFlowEngine.AvailableActivity w : this.workflowEngine.AvailableActivitiesToComplete){
            if(numberOfChecked < ALLOWED_NUMBER_OF_SELECTED_WOA){
                w.IsLimitMet = false;
                if(w.MarkToComplete){
                    w.ActivityRecord.is_Mass_Complete__c = true;
                }

            } else if(numberOfChecked >= ALLOWED_NUMBER_OF_SELECTED_WOA && !w.MarkToComplete){
                w.IsLimitMet = true;
                w.ActivityRecord.is_Mass_Complete__c = false;
            }

            // Defaulting values to 0 if activity is not selected
            if (!w.MarkToComplete) {
                w.userDurationInput = 0;
                //w.ActivityRecord.is_Mass_Complete__c = false;
                recountAvailableTime();
            }
        }
        // Check selectAllActivitiesToAutoComplete checkbox when the ALLOWED_NUMBER_OF_SELECTED_WOA is checked manually (so they do not have to make two clicks to uncheck all)
        Integer numberOfAvailableActivities = workflowEngine.AvailableActivitiesToComplete.size();
        if(numberOfChecked == ALLOWED_NUMBER_OF_SELECTED_WOA || numberOfChecked == numberOfAvailableActivities){
            checkedAll = true;
        } else {
            checkedAll = false;
        }
        return null;
    }

    // Select up to ALLOWED_NUMBER_OF_SELECTED_WOA Checkboxes
    public PageReference selectAllActivitiesToAutoComplete(){
        CountNumberOfChecked();
        for(VTT_WorkFlowEngine.AvailableActivity w : this.workflowEngine.AvailableActivitiesToComplete){
            if(checkedAll && numberOfChecked < ALLOWED_NUMBER_OF_SELECTED_WOA && !w.MarkToComplete){
                w.MarkToComplete = true;
                numberOfChecked++;
                w.IsLimitMet = false;
                w.ActivityRecord.is_Mass_Complete__c = true;
            } else if (checkedAll && w.MarkToComplete){
                w.IsLimitMet = false;
                w.ActivityRecord.is_Mass_Complete__c = true;
            } else if (!checkedAll) {
                w.MarkToComplete = false;
                w.IsLimitMet = false;
                w.userDurationInput = 0;
                recountAvailableTime();
                w.ActivityRecord.is_Mass_Complete__c = false;
            } else {
                w.IsLimitMet = true;
            }           
        }
        return null;
    }

    public void ValidateRunningTally() {
        recountAvailableTime();
        //first check if there are any autocomplete activities to be completed. If no, terminate
        if(numberOfChecked==0 || numberOfChecked == null){
            this.workflowEngine.runningTallyValueValid = true;
            return;
        }
        
        // Sets snapshot that will be used to set runningTally value back in case of error
        if(availableTimeSnapShot == null){
            availableTimeSnapShot = this.workflowEngine.runningTally;
        }

        if(availableTimeSnapShot != 0 && availableTimeSnapShot-1 < userTotalDuration) {
            ApexPages.addMessage(new ApexPages.Message(ApexPages.Severity.Error,  'Please update "Time to spend on selected WOA [min]". Running tally should be equal to or greater than 0'));
            this.workflowEngine.runningTallyValueValid = false;
        }

        for(VTT_WorkFlowEngine.AvailableActivity w : this.workflowEngine.AvailableActivitiesToComplete){
            if(w.MarkToComplete && w.userDurationInput==0){
                ApexPages.addMessage(new ApexPages.Message(ApexPages.Severity.Error,  'Please update "Time to spend on selected WOA [min]" or uncheck the Activity. You can not submit 0 time spent on Activity'));
                this.workflowEngine.runningTallyValueValid = false;
            } else if(w.MarkToComplete && w.userDurationInput<0) {
                ApexPages.addMessage(new ApexPages.Message(ApexPages.Severity.Error,  'Please update "Time to spend on selected WOA [min]". You can not submit negative time spent on activity'));
                this.workflowEngine.runningTallyValueValid = false;
            }
        }
        List<Apexpages.Message> msgs = ApexPages.getMessages();
        numOfPageMessages = msgs.size();
    }  
}